#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2014 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  read log file Script  -*-                        #
#                                                                              #
#                                                                              #
# This script read the $LOGFILENAME to convert to arrays                       #
# normaly generated by studio                                                  #
# These sub are included by scripts when studio is not involved in the process #
#                                                                              #
# Required global variables:                                                   #
#   $LOGFILENAME   : name of the log file to generate.                         #
#                                                                              #
################################################################################

sub readLogFile
{
my $what=shift; #s=TSF+FDC, o=OBJECTS, x=XOB, b=OTSFILES
$what='s' unless($what);
my $d=".";
my $code;
my $f;
  if(open IN, $LOGFILENAME) {
      while(<IN>){
		chomp;
		if(/^DIR\s+(.*)$/) {$d=$1; next;}
		if(/^DUM\s/) {next;}
		if(/^(\w\w\w)\s+(.*)$/) {
			$code=$1;$f=$2;
			$f=$d.'/'.$f unless(-f $f);
			if($code eq 'TSF') {if($what=~m/s/){ push(@TSFFILES,$f) unless( grep(/^\Q$f\E$/,@TSFFILES));} next;}
			if($code eq 'FDC') {if($what=~m/s/){ push(@FDCFILES,$f) unless( grep(/^\Q$f\E$/,@FDCFILES));} next;}
			if($code eq 'OBJ') {if($what=~m/o/){ push(@OBJECTS ,$f) unless( grep(/^\Q$f\E$/,@OBJECTS ));} next;}
			if($code eq 'OTS') {if($what=~m/b/){ push(@OTSFILES,$f) unless( grep(/^\Q$f\E$/,@OTSFILES));} next;}
			if($code eq 'XOB') {if($what=~m/x/){ push(@XOB     ,$f) unless( grep(/^\Q$f\E$/,@XOB     ));} next;}
			if($code eq 'MET') {if($what=~m/m/){ push(@MET     ,$f) unless( grep(/^\Q$f\E$/,@MET     ));} next;}
		}
      }
      close IN;
  }
}

sub cleanLogFile
{
my @rmFiles=@_;
my $currentDir="";
 if(open IN, $LOGFILENAME) {
    my $tsf=( $ATTMODE || $ATPMODE || $ATQMODE || $ATAMODE || $ATZMODE || $ATGMODE || $DCPMODE || $ATKMODE );
    my %seen = ();
    foreach(@rmFiles){$seen{$_}++;}
    open OU, ">$LOGFILENAME.tmp" or die &PerlTranslate("trtsplit.pl", "cannot write the temp log file.\n");
    while(<IN>){
	if(/(SVS|INC|DEF|FLG|#OPT|#TGT)\s/){print OU;next}
	chomp;
	if(/(\w{3})\s+(.+)$/){
	   my $tk=$1;
	   if(($currentDir=="") && ($tk eq 'DIR')) {
			$currentDir=$2;
	   }
	   my $pt=absolutePath($2,$currentDir);
	   unless( $seen{$pt}++){
		if(($tk eq 'DUM') && !($KEEP)) {
			# unlink absolute and relative files
			if (-f $pt) {
				unlink($pt);
#			} else {
#				unlink($currentDir."/".$2);
			}
		}
		elsif(($tk eq 'TDF') && !(-f $pt)){} #remove the line if the file has been splitted
		else {print OU "$tk $2\n" ;}
	   }
	} else {
	    print "unknown line in log file $_\n";
	}
   }
   close IN;
   close OU;
   rename($LOGFILENAME.'.tmp',$LOGFILENAME);
 } else {
	&PerlTranslate("trtsplit.pl", "No result log found.\n");
 }
}

1;
